#!/bin/sh -e

SDIR="fproxy-target"
TDIR="$1"
TUID="$2"
TGID="$3"

if [ -z "$TDIR" ] || [ -z "$TUID" ] || [ -z "$TGID" ]; then
  echo "Usage: install-secure.sh /path/to/target/newdir target_uid target_gid"
  exit 1
fi

if [ ! -d "$SDIR" ]; then
  echo "Please run ./prepare-dir.sh first"
  exit 1
fi

if [ -e "$TDIR" ]; then
  echo "Something at $TDIR already exists - delete it first or select another target dir"
  exit 1
fi

if [ `id -u` != 0 ]; then
  echo "Need to run as root"
  exit 1
fi

mkdir "$TDIR"

if [ ! -d "$TDIR" ]; then
  echo "Failed to create $TDIR"
  exit 1
fi

tar -C "$SDIR" -c -f - . | tar -C "$TDIR" -x -f -
chown -R "0:$TGID" "$TDIR"
chmod 755 "$TDIR"
cd "$TDIR"
chmod 770 cache_data cache_real saved_data saved_real internal dyn-certs proxy_temp log
chmod 775 tmp

chmod 750 cert-pin pem
chmod 770 cert-pin/*
chmod 440 pem/*

chmod 440 rules_*.txt
chmod 660 dyn-cert-serial
chmod 440 mincache.time offline.flag

echo "DONE"
