#!/bin/sh -e

cd config/types
./gentypes.sh
mv types.h ../work/types.h
cd ../work
CCI ../opts-config.c
LDI opts-config opts-config.o
./opts-config "$@" > config.h
../syslib/config.sh ../syslib >> config.h
cp ../syslib/string.h string.h
if grep -F HAVE_EXPLICIT_BZERO config.h >> /dev/null; then
  grep -v -F "define FCL_EXPLICIT_BZERO" string.h > string.hh
  mv string.hh string.h
fi
if grep -F HAVE_STRLCPY config.h >> /dev/null; then
  grep -v -F "define FCL_STRLCPY" string.h > string.hh
  mv string.hh string.h
fi
if grep -F FCL_NO_STRERROR config.h > strerror.inc; then
  echo "strerror() caching disabled"
else
  grep -F FCL_STRERROR_STATIC config.h >> strerror.inc || true
  CCI ../errno-gen.c
  LDI errno-gen errno-gen.o
  ./errno-gen >> strerror.inc
fi
cd ../..
DELOBJ
CCI inifile.c
CCI recvbuf.c
CCI conio/conio.c
CCI conio/vt100key.c
CCI conio/getch.c
CCI strparse.c
CCI strparse_fp.c
CCI strparse_sys.c
CCI strerror.c
CCI -O3 strhash.c
CCI string.c
CCI qlog.c
CCI qprint.c
CCI qprintfd.c
CCI qscan.c
CCI malloc.c
CCI malloc_debug.c
CCI -DHT_STATIC -o hashtbls.o hashtbl.c
CCI -DHT_MALLOC -o hashtblm.o hashtbl.c
CCI -DHT_CUSTOM -o hashtblc.o hashtbl.c
CCI dynbufs.c
CCI -O2 -fno-strict-aliasing endian.c
# CCI io.c
CCI threads.c || echo "skipping threads"
CCI charset/gen.c
LDI gen gen.o
rm gen.o
echo "Compiling: charset/charsets.lst"
./gen < charset/charsets.lst > charsets.inc 2> gen.log
CCI charset/charset.c
AR libfcl.a *.o
HEADERS fcl *.h conio/*.h charset/charset.h
HEADERS fcl config/work/string.h config/work/types.h
DELOBJ
rm gen gen.log charsets.inc

