#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef SCAN_LEN
#define SCAN_LEN 256
#endif

static char const * errstrs[SCAN_LEN];

static void print_err(char const * st);

int main(void) {
  int e, ne, se;
  char const *s, *p, *e0, *e1;
  unsigned int e0l, e1l, tl;
  
  char t[10];
  
  if(SCAN_LEN<10) return -1;
  
  for(e=0; e<SCAN_LEN; e++) {
    s = strerror(e);
    if(s) {
      s = strdup(s);
      if(!s) { fprintf(stderr, "[errno-gen] out of memory\n"); return -1; }
      errstrs[e] = s;
    }
  }
  
  sprintf(t, "%d", (int)(SCAN_LEN-2));
  tl = strlen(t);
  if((e0=errstrs[SCAN_LEN-2]) && strlen(e0)<1000 && (p=strstr(e0,t))) {
    e0l = p-e0;
    e1 = p+tl;
    e1l = strlen(e1);
    for(ne=SCAN_LEN-1; ne>=0; ne--) {
      sprintf(t, "%d", ne);
      tl = strlen(t);
      s = errstrs[ne];
      if(s && (strlen(s)!=e0l+tl+e1l || memcmp(s,e0,e0l) ||
        memcmp(s+e0l,t,tl) || memcmp(s+e0l+tl,e1,e1l))) break;
    }
    se = 0;
    ne++;
    if(ne>1 && (!(s=errstrs[0]) || strlen(s)==e0l+1+e1l &&
      !memcmp(s,e0,e0l) && s[e0l]=='0' && !memcmp(s+e0l+1,e1,e1l))) se++;
    fprintf(stderr, "[errno-gen] we have errno's %d..%d\n", se, ne-1);
  } else {
    se = 0;
    ne = SCAN_LEN;
    for(ne=SCAN_LEN; ne>0; ne--) if(errstrs[ne-1]) break;
    if(ne>1 && !errstrs[0]) se++;
    if(ne<SCAN_LEN)
      fprintf(stderr, "[errno-gen] we have errno's %d..%d\n", se, ne-1);
    else fprintf(stderr, "[errno-gen] warning: couldn't detect maximum errno "
                    "value in range 1..%d\n",(int)(SCAN_LEN-2));
  }
  
  printf("#define FCL_ERRNO_NUM %d\n", (int)SCAN_LEN);
  printf("static char const * const fcl_errno_cache[FCL_ERRNO_NUM] = { \n");
  if(se) errstrs[0] = NULL;
  for(e=0; e<ne; e++) {
    if(e) fputs(",\n",stdout);
    print_err(errstrs[e]);
  }
  printf("\n};\n");
  return 0;
}

static void print_err(char const * st) {
  unsigned char c;
  if(!st) { fputs("  NULL", stdout); return; }
  fputs("  \"",stdout);
  while(c=*(unsigned char*)(st++)) {
    if(c=='\\' || c=='"') putc('\\',stdout);
    else if(c==127) { fputs("\\177", stdout); continue; }
    else if(c>0 && c<32) { printf("\\0%d%d",(int)(c/8),(int)(c%8)); continue; }
    putc(c,stdout);
  }
  putc('"',stdout);
}
