/*
 * This file is part of firk's Common C Library
 *  gensizet.c - generate types.h fcl_size_t part
 *
 * (c) firk 2021; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif
#include <stdio.h>

int main(void) {
#ifdef CHECK_OK
  return 0;
#else
#ifdef CHECK_SIZET_PRESENT
  size_t x;
  x = 1;
  return 0;
#else
  unsigned MT i, *pi;
#ifdef CHECK_SIZET_MATCH
  size_t s, *ps;
  s = 0; i = 0;
  ps = &i; pi = &s; ps = pi;
  if(sizeof(s)!=sizeof(i)) {
    fprintf(stderr,"> error: compiled succesfully for incompatible types: size_t(%u) vs u"MTSTR"(%u)\n", (unsigned)sizeof(size_t), (unsigned)sizeof(unsigned MT));
    return -1;
  }
#else
  i = sizeof(i); pi = &i;
  if(sizeof(i)!=sizeof sizeof 1) return -1;
#endif
  fputs("> ok: size_t is unsigned "MTSTR"\n", stderr);
  fputs("typedef unsigned "MTSTR" fcl_size;\n", stdout);
  fputs("typedef signed "MTSTR" fcl_ssize;\n", stdout);
  if(sizeof(i)<sizeof(unsigned int)) {
    fputs("typedef unsigned int fcl_va_size;\n", stdout);
    fputs("typedef signed int fcl_va_ssize;\n", stdout);
  } else {
    fputs("typedef unsigned "MTSTR" fcl_va_size;\n", stdout);
    fputs("typedef signed "MTSTR" fcl_va_ssize;\n", stdout);
  }
  return 0;
#endif
#endif
}

