#!/bin/sh -e

cp types.h0 types.h

echo "Generating: types.h"
if CCITESTRUN ./gentypes -DHAVE_LONGLONG gentypes.c 2>&1 >> types.h; then
  true
elif CCITESTRUN ./gentypes gentypes.c 2>&1 >> types.h; then
  true
else
  echo "failed to compile gentypes.c"
  exit 1
fi

echo -n "> have 'size_t'? "
if CCITESTOK ./gensizet.o -DHAVE_SYS_TYPES_H -DCHECK_SIZET_PRESENT gensizet.c; then
  echo "yes, with sys/types.h"
  ARG="-DHAVE_SYS_TYPES_H -DCHECK_SIZET_MATCH"
elif CCITESTOK ./gensizet.o -DCHECK_SIZET_PRESENT gensizet.c; then
  echo "yes, without sys/types.h"
  ARG="-DCHECK_SIZET_MATCH"
elif CCITESTOK ./gensizet.o gensizet.c; then
  echo "no"
  ARG=""
else
  echo "failed to compile gensizet.c stage 1"
  exit 1
fi

CCITESTRUN ./gensizet $ARG -DMT=short -DMTSTR=\"short\" gensizet.c 2>&1 >> types.h || \
  CCITESTRUN ./gensizet $ARG "-DMT=long long" "-DMTSTR=\"long long\"" gensizet.c 2>&1 >> types.h || \
  CCITESTRUN ./gensizet $ARG -DMT=int -DMTSTR=\"int\" gensizet.c 2>&1 >> types.h || \
  CCITESTRUN ./gensizet $ARG -DMT=long -DMTSTR=\"long\" gensizet.c 2>&1 >> types.h || \
  exit 1



if CCITESTOK ./inline.o -DFCL_INLINE="static __inline__ __attribute__((always_inline))" inline.c; then
  echo "" >> types.h
  echo "#define FCL_INLINE static __inline__ __attribute__((always_inline))" >> types.h
elif CCITESTOK ./inline.o -DFCL_INLINE="static inline" inline.c; then
  echo "" >> types.h
  echo "#define FCL_INLINE static inline" >> types.h
fi

cat types.h1 >> types.h

echo "Verifying: types.h"
echo -n "> "
CCITESTRUN ./types-check types.c -Dall=0 -Dverbose=0 -Wno-overflow -Wno-error
