/*
 * This file is part of firk's Common C Library
 *  conio/keycodes.h - keyboard key codes
 *
 * (c) firk 2021, 2022; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef FCL_INCLUDED_KEYCODES_H
#define FCL_INCLUDED_KEYCODES_H

#define KeyTab     0x009
#define KeyEnter   0x00D
#define KeyQuit    0x100
#define KeyF1      0x101
#define KeyF2      0x102
#define KeyF3      0x103
#define KeyF4      0x104
#define KeyF5      0x105
#define KeyF6      0x106
#define KeyF7      0x107
#define KeyF8      0x108
#define KeyF9      0x109
#define KeyF10     0x10A
#define KeyF11     0x10B
#define KeyF12     0x10C
#define KeyF13     0x10D
#define KeyF14     0x10E
#define KeyF15     0x10F
#define KeyF16     0x110
#define KeyF17     0x111
#define KeyF18     0x112
#define KeyF19     0x113
#define KeyF20     0x114
#define MKeyAlt    0x200
#define MKeyCtrl   0x400
#define MKeyShift  0x800
#define KeyHome    0x120
#define KeyEnd     0x121
#define KeyPgUp    0x122
#define KeyPgDn    0x123
#define KeyUp      0x124
#define KeyDown    0x125
#define KeyLeft    0x126
#define KeyRight   0x127
#define KeyCenter  0x128
#define KeyInsert  0x129
#define KeyDelete  0x12A
#define KeyKPlus   0x12B
#define KeyKMinus  0x12C
#define KeyKMul    0x12D
#define KeyKDiv    0x12E
#define KeyKEnter  0x12F
#define KeyKComma  0x130 /* not on PC keyboard but may be emulated */
#define KeyKEqual  0x131 /* not on PC keyboard but may be emulated */

#endif

