/*
 * This file is part of firk's Common C Library
 *  string.c - openbsd-compatible wrapper for string.h/strings.h/w.e.
 *
 * (c) firk 2019; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

#include "string.h"

#ifdef FCL_EXPLICIT_BZERO
extern void explicit_bzero(void * p, size_t len) {
  bzero(p, len);
  __asm volatile ("" ::: "memory");
}
#endif

#ifdef FCL_STRLCPY
extern size_t strlcpy(char * dest, char const * src, size_t dstsize) {
  size_t pos;
  char c;
  if(!dstsize) return 0;
  dstsize--;
  for(pos=0; pos<dstsize && (c=src[pos]); pos++) dest[pos] = c;
  dest[pos] = 0;
  while(c=src[pos]) pos++; /* this reduces stability but required by manpage */
  return pos;
}
#endif

static int dummy = 0;
