/*
 * This file is part of firk's Common C Library
 *  threads.h - threads
 *
 * (c) firk 2020; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FCL_THREADS_H
#define INCLUDED_FCL_THREADS_H

#ifdef FCL_SIMPLE_NAMES
#define init_threads fcl_init_threads
#define thread_create fcl_thread_create
#define thread_is_finished fcl_thread_is_finished
#define thread_wait fcl_thread_wait
#define thread_nowait fcl_thread_nowait
#endif

typedef int (* fcl_thread_func)(void * p);
typedef struct fcl_thread fcl_thread;

#ifdef FCL_SIMPLE_NAMES
typedef fcl_thread_func thread_func;
typedef fcl_thread thread;
#endif

extern void fcl_init_threads(unsigned int n);
/* TODO: fcl_done_threads(void); */
extern fcl_thread * fcl_thread_create(fcl_thread_func tf, void * p);
extern int fcl_thread_is_finished(fcl_thread * th);
extern int fcl_thread_wait(fcl_thread * th);
/* TODO: extern void fcl_thread_nowait(fcl_thread * th); */

#endif

