/*
 * This file is part of firk's Cryptography Library
 * aes.h - AES-256 cipher implementation
 * (c) firk 2015; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FCRYPT_AES256_H
#define INCLUDED_FCRYPT_AES256_H

typedef struct _aes256_key {
  uint32    rndkeys[60];
} aes256_key;

extern int aes256_prepare_key(aes256_key * k, uint32 * key);
extern void aes256_encrypt(aes256_key * k, uint32 * data);
extern void aes256_decrypt(aes256_key * k, uint32 * data);

#endif

