#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcl/types.h>
#include "aes256.h"

static uint8 key256[32] = {
  0xef, 0xcd, 0xab, 0x89, 0x67, 0x45, 0x23, 0x01, 0x10, 0x32, 0x54, 0x76, 0x98, 0xba, 0xdc, 0xfe,
  0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11, 0x00, 0xff, 0xee, 0xdd, 0xcc, 0xbb, 0xaa, 0x99, 0x88
};

static uint8 plaintext[16] = {
  0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff, 0x00, 0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11
};

static uint8 ciphertext[16] = {
  0x66, 0x90, 0xAC, 0xE8, 0xDD, 0x99, 0x40, 0x61, 0xA1, 0x75, 0x0D, 0x54, 0xA6, 0xA1, 0x5D, 0x7B
};

static aes256_key k;
static uint8 data[16];

static void blk2_action(int ac) {
  if(!ac) aes256_encrypt(&k, (uint32*)data);
  else aes256_decrypt(&k, (uint32*)data);
}

int main(int argc, char * * argv) {
  uint32 c;
  int mode;
  if(argc!=3) return -1;
  mode = atoi(argv[1]);
  c = atoi(argv[2]);
  c *= 65536; /* 16384 cycles = 1MB output */
  aes256_prepare_key(&k, (uint32*)key256);
  if(!(mode & 1)) {
    bcopy(plaintext, data, 16);
    blk2_action(0);
    if(bcmp(ciphertext,data,16)) { fprintf(stderr,"mismatch!\n"); return -1; }
  } else {
    bcopy(ciphertext, data, 16);
    blk2_action(1);
    if(bcmp(plaintext,data,16)) { fprintf(stderr,"mismatch!\n"); return -1; }
  }
  switch(mode) {
  case 0: while(c--) aes256_encrypt(&k, (uint32*)data); return 0;
  case 1: while(c--) aes256_decrypt(&k, (uint32*)data); return 0;
  case 2:
  case 3: while(c--) aes256_prepare_key(&k, (uint32*)key256); return 0;
  }
  return 0;
}
