#!/bin/sh -e

AES="$1"
BENCH="$2"
W="work"

if [ ! -f "$W/aes_mix.h" ]; then
  CCI helper/aesgen3.c -o "$W/aesgen3.o"
  LDI "$W/aesgen3" "$W/aesgen3.o"
  "$W/aesgen3" > "$W/aes_mix.h"
  rm "$W/aesgen3" "$W/aesgen3.o"
fi
if [ ! -f "$W/aes_mix.inc" ]; then
  CCI helper/aesgen3a.c -o "$W/aesgen3a.o"
  LDI "$W/aesgen3a" "$W/aesgen3a.o"
  "$W/aesgen3a" > "$W/aes_mix.inc"
  rm "$W/aesgen3a" "$W/aesgen3a.o"
fi

if [ "$AES" = "" ]; then
  CCI -O1 -I. "-I$W" aes/aes256.c -o aes256.o
elif [ "$AES" = "v2" ]; then
  CCI -O1 "-I$W" -DINLINE_RBOX aes/aes256.S -o aes256.o
elif [ "$AES" = "v2x2" ]; then
  CCI -O1 "-I$W" -DINLINE_RBOX -DAES_USE_SSE aes/aes256.S -o aes256.o
else
  echo "unknown aes256 compile mode"
  exit 1
fi

if [ -n "$BENCH" ]; then
  if ( uname -a | grep Linux >> /dev/null ) ; then
    TIME="time -f real=%e;user=%U;sys=%S"
  else
    TIME="time"
  fi
  CCI aes/bench.c
  LDI bench aes256.o bench.o
  rm aes256.o bench.o
  echo "enc $AES $BENCH MBytes"
  $TIME ./bench 0 "$BENCH"
  echo "dec $AES $BENCH MBytes"
  $TIME ./bench 1 "$BENCH"
  echo "pre $AES $BENCH MBytes"
  $TIME ./bench 2 "$BENCH"
  echo "Done"
  rm bench
fi

exit 0
