#!/bin/sh -e

ARCH=`uname -m`
if ( echo "$ARCH" | grep 64 >> /dev/null ) && ! ( grep LONG_GE64 ../fcl/config/work/types.h ); then
  ARCH=unknown
fi
cd work
CCI ../config/opts-config.c
LDI opts-config opts-config.o
./opts-config "--arch=$ARCH" "$@" > config.sh
cd ..

. work/config.sh

echo "Using:"
cat work/config.sh

DELOBJ
CCI -O1 rc4.c
CCI -O1 -DMD5_NO_WARN md5.c
CCI -O1 sha1.c
CCI -O1 sha256.c
CCI -O1 sha512.c
CCI -DMD5_NO_WARN hmac.c
CCI -O1 -I. aes/aes.c
./aes/build.sh "$AES"
./salsa20/build.sh "$SALSA20"
./kuznyechik/build.sh "$KUZ"
AR libfcrypt.a *.o
HEADERS fcrypt rc4.h sha1.h sha256.h sha512.h aes/aes.h salsa20/salsa20.h \
  aes/aes256.h hmac.h md5.h kuznyechik/kuznyechik.h
DELOBJ

CCI -DMD5_NO_WARN fcrypt_t.c
LDI fcrypt fcrypt_t.o -lfcrypt -lfcl
DELOBJ

INSTBIN fcrypt

echo "Done"
