/* AES mul table generator */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "../../fcl/types.h"

static uchar aes_mul(uchar a, uchar b) {
  uchar r;
  r = 0;
  while(b) {
    if(b&1) r^=a;
    b>>=1;
    if(a&0x80) { a = (a<<1)^0x1B; } else a<<=1;
  }
  return r;
}

int main(void) {
  uint a, b;
  printf("static uchar aes_mul_table[0x10000] = {\n");
  for(a=0; a<256; a++) {
    for(b=0; b<256; b++) {
      if(!(b%8)) printf("  ");
      printf("0x%02X", aes_mul((uchar)a,(uchar)b));
      if(b==255 && a==255) printf("\n};\n\n");
      else if((b%8)==7) printf(",\n");
      else printf(", ");
    }
  }
  return 0;
}
