/* AES mul table generator */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "../../fcl/types.h"

static uchar aes_mul(uint a0, uchar b) {
  uchar a, r;
  a = (uchar)a0;
  r = 0;
  while(b) {
    if(b&1) r^=a;
    b>>=1;
    if(a&0x80) { a = (a<<1)^0x1B; } else a<<=1;
  }
  return r;
}

int main(void) {
  uint32 a, b;
  for(b=0; b<8; b++) {
    printf("aes_mix%d:\n", b);
    for(a=0; a<256; a++) {
      if(!(a%4)) printf("\t.byte ");
      switch(b) {
      case 0:
        printf("0x%02X,0x%02X,0x%02X,0x%02X", aes_mul(2,a), a, a, aes_mul(3,a));
        break;
      case 1:
        printf("0x%02X,0x%02X,0x%02X,0x%02X", aes_mul(3,a), aes_mul(2,a), a, a);
        break;
      case 2:
        printf("0x%02X,0x%02X,0x%02X,0x%02X", a, aes_mul(3,a), aes_mul(2,a), a);
        break;
      case 3:
        printf("0x%02X,0x%02X,0x%02X,0x%02X", a, a, aes_mul(3,a), aes_mul(2,a));
        break;
      case 4:
        printf("0x%02X,0x%02X,0x%02X,0x%02X",
          aes_mul(14,a), aes_mul(9,a), aes_mul(13,a), aes_mul(11,a));
        break;
      case 5:
        printf("0x%02X,0x%02X,0x%02X,0x%02X",
          aes_mul(11,a), aes_mul(14,a), aes_mul(9,a), aes_mul(13,a));
        break;
      case 6:
        printf("0x%02X,0x%02X,0x%02X,0x%02X",
          aes_mul(13,a), aes_mul(11,a), aes_mul(14,a), aes_mul(9,a));
        break;
      case 7:
        printf("0x%02X,0x%02X,0x%02X,0x%02X",
          aes_mul(9,a), aes_mul(13,a), aes_mul(11,a), aes_mul(14,a));
        break;
      }
      fputc(((a%4)==3)?'\n':',',stdout);
    }
  }
  return 0;
}
