/* Kuznyechik mul table generator - alternative */
/* (c) 2021 firk */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "../../fcl/types.h"

static uint8 powers_of_2[256];
static uint8 revpow_of_2[256];

static uint8 kuz_mul(uint8 a, uint8 b) {
  uint8 c;
  c = 0;
  while(b) {
    if(b&1) c^=a;
    b>>=1;
    if(a&0x80) { a = (a<<1)^0xC3; } else { a = (a<<1); }
  }
  return c;
}

static uint8 kuz_mul_ex(uint8 a, uint8 b) {
  if(!a || !b) return 0;
  return powers_of_2[(revpow_of_2[a]+revpow_of_2[b])%255];
}

int main(void) {
  uint a, b;
  powers_of_2[0] = 1;
  revpow_of_2[1] = 0;
  for(a=1; a<256; a++) {
    b = powers_of_2[a] = kuz_mul(powers_of_2[a-1],2);
    if(!b) {
      fprintf(stderr, "kuzgen1a: 2^%u==0\n", a);
      exit(-1);
    }
    if(a!=255 && b==1) {
      fprintf(stderr, "kuzgen1a: powers_of_2 not complete!\n");
      exit(-1);
    }
    if(a==255 && b!=1) {
      fprintf(stderr, "kuzgen1a: 2^255!=1\n");
      exit(-1);
    }
    if(b>1) {
      if(revpow_of_2[b]) {
        fprintf(stderr, "kuzgen1a: 2^%u==%u==2^%u\n", a, b, revpow_of_2[b]);
        exit(-1);
      }
      revpow_of_2[b] = a;
    }
  }
  printf("static uint8 const kuz_powers_of_2[768] = {\n  ");
  for(a=0; a<512; a++) {
    printf("%3u", powers_of_2[a%255]);
    if(a%16!=15) printf(",");
    else if(a<511) printf(",\n  ");
  }
  printf("\n};\n\nstatic uint const kuz_revpow_of_2[256] = {\n  512,");
  for(a=1; a<256; a++) {
    printf("%3u", revpow_of_2[a]);
    if(a%16!=15) printf(",");
    else if(a<255) printf(",\n  ");
  }
  printf("\n};\n\n");
  for(a=0; a<256; a++) for(b=0; b<256; b++) if(kuz_mul(a,b)!=kuz_mul_ex(a,b)) {
    fprintf(stderr, "kuzgen1a: err %u %u\n", a, b);
  }
  return 0;
}

