/* Kuznyechik C1-C32 generator */
/* (c) 2021 firk */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "../../fcl/types.h"

static uint8 kuz_mul(uint8 a, uint8 b) {
  uint8 c;
  c = 0;
  while(b) {
    if(b&1) c^=a;
    b>>=1;
    if(a&0x80) { a = (a<<1)^0xC3; } else { a = (a<<1); }
  }
  return c;
}

/* 4.1.2 (1) */
static uint8 kuz_mix8(uint8 const * a) {
  return
    kuz_mul(148,a[15])^kuz_mul( 32,a[14])^
    kuz_mul(133,a[13])^kuz_mul( 16,a[12])^
    kuz_mul(194,a[11])^kuz_mul(192,a[10])^
    kuz_mul(  1,a[ 9])^kuz_mul(251,a[ 8])^
    kuz_mul(  1,a[ 7])^kuz_mul(192,a[ 6])^
    kuz_mul(194,a[ 5])^kuz_mul( 16,a[ 4])^
    kuz_mul(133,a[ 3])^kuz_mul( 32,a[ 2])^
    kuz_mul(148,a[ 1])^kuz_mul(  1,a[ 0]);
}

/* 4.2 (5), (6); input: a[0..15], output: a[16..31] */
static void kuz_mix128(uint8 * a) {
  uint i;
  for(i=0; i<16; i++) a[16+i] = kuz_mix8(a+i);
}

int main(int argc, char * * argv) {
  uint8 d[32];
  uint a, b;
  int as;
  
  as = (argc>=2 && !strcmp(argv[1],"asm"));
  printf(as?"kuz_const_table:\n"
           :"static uint8 const kuz_const_table[32*16] = {\n");
  for(a=1; a<=32; a++) {
    d[0]=a;
    for(b=1;b<16;b++) d[b]=0;
    kuz_mix128(d);
    printf(
      as?"\t.byte 0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X\n"
         "\t.byte 0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X\n"
        :" 0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,\n"
         " 0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",
           d[16],d[17],d[18],d[19],d[20],d[21],d[22],d[23],
           d[24],d[25],d[26],d[27],d[28],d[29],d[30],d[31]);
    if(!as && a<32) fputs(",\n", stdout);
  }
  if(!as) printf("\n};\n\n");
  return 0;
}
