/* Kuznyechik fastmix table generator */
/* (c) 2021 firk */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "../../fcl/types.h"

static uint8 const kk[16] =
  { 1,148,32,133, 16,194,192,1, 251,1,192,194, 16,133,32,148 };

static uint8 kuz_mul(uint8 a, uint8 b) {
  uint8 c;
  c = 0;
  while(b) {
    if(b&1) c^=a;
    b>>=1;
    if(a&0x80) { a = (a<<1)^0xC3; } else { a = (a<<1); }
  }
  return c;
}

static uint8 k[16][16];

int main(int argc, char * * argv) {
  uint i, j, n;
  for(i=0; i<16; i++) {
  /*
    a[16+i] = kk[15]*a[15+i] + ... + kk[0]*a[i] = 
     = k[i][15]*a[15] + ... + k[i][0]*a[0]
   */
    /* kk[j-i]*a[(j-i)+i] */
    for(j=i; j<16; j++) k[i][j] ^= kk[j-i];
    /* kk[16+j-i]*a[(16+j-i)+i] = kk[16+j-i]*a[16+j] =
      = kk[16+j-i] * ( k[j][15]*a[15] + ... + k[j][0]*a[0] )
     */
    for(j=0; j<i; j++) { /* kk[16-i] ... kk[15] */
      for(n=0; n<16; n++) {
        k[i][n] ^= kuz_mul(kk[16+j-i], k[j][n]);
      }
    }
  }

  if(argc>1) for(i=0; i<16; i++) {
    fprintf(stderr,"a[16+%u] = ", i);
    for(j=0; j<16; j++) {
      fprintf(stderr,"%u*a[%u]", k[i][j], j);
      if(j==15) fprintf(stderr,"\n"); else fprintf(stderr," + ");
    }
  }

  printf("static uint8 const kuz_mix[16][256][16] = {\n");
  for(j=0; j<16; j++) {
    printf("{\n");
    for(n=0; n<256; n++) {
      printf("  { ");
      for(i=0;i<16;i++) {
        printf("%3u", kuz_mul(k[i][j],n));
        if(i!=15) printf(",");
      }
      printf((n==255)?" }\n":" },\n");
    }
    printf((j==15)?"}\n":"},\n");
  }
  printf("};\n\n");

  /* mirror */
  printf("static uint8 const kuz_unmix[16][256][16] = {\n");
  for(j=0; j<16; j++) {
    printf("{\n");
    for(n=0; n<256; n++) {
      printf("  { ");
      for(i=0;i<16;i++) {
        printf("%3u", kuz_mul(k[15-i][15-j],n));
        if(i!=15) printf(",");
      }
      printf((n==255)?" }\n":" },\n");
    }
    printf((j==15)?"}\n":"},\n");
  }
  printf("};\n\n");
  return 0;
}

