#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcl/types.h>
#include "kuznyechik.h"

static uint8 key256[32] = {
  0xef, 0xcd, 0xab, 0x89, 0x67, 0x45, 0x23, 0x01,
  0x10, 0x32, 0x54, 0x76, 0x98, 0xba, 0xdc, 0xfe,
  0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11, 0x00,
  0xff, 0xee, 0xdd, 0xcc, 0xbb, 0xaa, 0x99, 0x88
};

static uint8 plaintext[16] = {
  0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff,
  0x00, 0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11
};

static uint8 ciphertext[16] = {
  0xcd, 0xed, 0xd4, 0xb9, 0x42, 0x8d, 0x46, 0x5a,
  0x30, 0x24, 0xbc, 0xbe, 0x90, 0x9d, 0x67, 0x7f
};

static kuz_key k;
static uint8 data[16];

static void blk2_action(int ac) {
  if(!ac) kuz_encrypt(&k, data);
  else kuz_decrypt(&k, data);
}

int main(int argc, char * * argv) {
  uint32 c;
  int mode;
  if(argc!=3) return -1;
  mode = atoi(argv[1]);
  c = atoi(argv[2]);
  c *= 65536; /* 16384 cycles = 1MB output */
  kuz_prepare_key(&k, key256);
  if(!(mode & 1)) {
    bcopy(plaintext, data, 16);
    blk2_action(0);
    if(bcmp(ciphertext,data,16)) { fprintf(stderr,"mismatch!\n"); return -1; }
  } else {
    bcopy(ciphertext, data, 16);
    blk2_action(1);
    if(bcmp(plaintext,data,16)) { fprintf(stderr,"mismatch!\n"); return -1; }
  }
  switch(mode) {
  case 0: while(c--) kuz_encrypt(&k, data); return 0;
  case 1: while(c--) kuz_decrypt(&k, data); return 0;
  case 2:
  case 3: while(c--) kuz_prepare_key(&k, key256); return 0;
  }
  return 0;
}
