#!/bin/sh -e

KUZ="$1"
BENCH="$2"
W="work"

if [ ! -f "$W/kuz_fastmix.h" ]; then
  CCI helper/kuzgen3.c -o "$W/kuzgen3.o"
  LDI "$W/kuzgen3" "$W/kuzgen3.o"
  "$W/kuzgen3" > "$W/kuz_fastmix.h"
  rm "$W/kuzgen3" "$W/kuzgen3.o"
fi
if [ ! -f "$W/kuz_fastmix_m.h" ]; then
  CCI helper/kuzgen3m.c -o "$W/kuzgen3m.o"
  LDI "$W/kuzgen3m" "$W/kuzgen3m.o"
  "$W/kuzgen3m" > "$W/kuz_fastmix_m.h"
  rm "$W/kuzgen3m" "$W/kuzgen3m.o"
fi
if [ ! -f "$W/kuz_fastmix_m.inc" ]; then
  CCI helper/kuzgen3m.c -o "$W/kuzgen3m.o"
  LDI "$W/kuzgen3m" "$W/kuzgen3m.o"
  "$W/kuzgen3m" asm > "$W/kuz_fastmix_m.inc"
  rm "$W/kuzgen3m" "$W/kuzgen3m.o"
fi

if [ "$KUZ" = "" ]; then
  CCI -O1 "-I$W" kuznyechik/kuznyechik.c -o kuznyechik.o
elif [ "$KUZ" = "x" ]; then
  # doesn't work with new gcc
  CCI -O1 "-I$W" -DKUZ_USE_SSE kuznyechik/kuznyechik.c -o kuznyechik.o
elif [ "$KUZ" = "x2" ]; then
  CCI -O1 "-I$W" -DKUZ_USE_SSE -msse2 kuznyechik/kuznyechik.c -o kuznyechik.o
elif [ "$KUZ" = "v2" ]; then
  CCI -O1 "-I$W" kuznyechik/kuznyechik_v2.c -o kuznyechik.o
elif [ "$KUZ" = "v2x" ]; then
  # doesn't work with new gcc
  CCI -O1 "-I$W" -DKUZ_USE_SSE kuznyechik/kuznyechik_v2.c -o kuznyechik.o
elif [ "$KUZ" = "v2x2" ]; then
  CCI -O1 "-I$W" -DKUZ_USE_SSE -msse2 kuznyechik/kuznyechik_v2.c -o kuznyechik.o
elif [ "$KUZ" = "v3" ]; then
  CCI -O1 "-I$W" kuznyechik/kuznyechik_v3.S -o kuznyechik.o
elif [ "$KUZ" = "v3x2" ]; then
  CCI -O1 "-I$W" -DKUZ_USE_SSE kuznyechik/kuznyechik_v3.S -o kuznyechik.o
elif [ "$KUZ" = "v3_64" ]; then
  CCI -m64 -O1 "-I$W" kuznyechik/kuznyechik_v3_amd64.S -o kuznyechik.o
elif [ "$KUZ" = "v3x2_64" ]; then
  CCI -m64 -O1 "-I$W" -DKUZ_USE_SSE kuznyechik/kuznyechik_v3_amd64.S -o kuznyechik.o
elif [ "$KUZ" = "v3x2_64a" ]; then
  CCI -m64 -O1 "-I$W" -DKUZ_USE_SSE -DASSUME_STACK_ALIGNMENT=8 kuznyechik/kuznyechik_v3_amd64.S -o kuznyechik.o
else
  echo "unknown kuznyechik compile mode"
  exit 1
fi

if [ -n "$BENCH" ]; then
  if ( uname -a | grep Linux >> /dev/null ) ; then
    TIME="time -f real=%e;user=%U;sys=%S"
  else
    TIME="time"
  fi
  CCI kuznyechik/bench.c
  LDI bench kuznyechik*.o bench.o
  rm kuznyechik*.o bench.o
  echo "enc $KUZ $BENCH MBytes"
  $TIME ./bench 0 "$BENCH"
  echo "dec $KUZ $BENCH MBytes"
  $TIME ./bench 1 "$BENCH"
  echo "pre $KUZ $BENCH MBytes"
  $TIME ./bench 2 "$BENCH"
  echo "Done"
  rm bench
fi

exit 0
