/*
 * This file is part of firk's Cryptography Library
 * (c) firk 2020; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FCRYPT_MD5_H
#define INCLUDED_FCRYPT_MD5_H

#ifndef MD5_NO_WARN
#warning "MD5 is obsolete long ago, do not use"
#endif

typedef struct _md5_ctx {
    uint32  state[4];
    uint64  len;
    uint8   data[64];
} md5_ctx;

extern void md5_init(md5_ctx * ctx);
extern void md5_transform(uint8 const * data,  uint32 * state);
extern void md5_update(md5_ctx * ctx, uint8 const * data, size_t len);
extern void md5_final(md5_ctx * ctx, uint8 * hash);
extern void md5_hash(uint8 * hash, char const * data, size_t len);

#endif

