/*
 * This file is part of firk's Cryptography Library
 * (c) firk 2008, 2011, 2015; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FCRYPT_RC4_H
#define INCLUDED_FCRYPT_RC4_H

typedef struct _rc4_ctx {
  unsigned char data[0x100];
  unsigned char i, j;
} rc4_ctx, RC4Key;

extern void RC4_makekey(RC4Key * key, unsigned char const * src,
                        size_t srclen, unsigned int droplen);
extern void RC4_keydrop(RC4Key * key, unsigned int droplen);
extern void RC4_xorcrypt(RC4Key * key, unsigned char * data, size_t len);

#endif

