/*
 * This file is part of firk's Cryptography Library
 * (c) firk 2014, 2015; firk@cantconnect.ru
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FCRYPT_SHA512_H
#define INCLUDED_FCRYPT_SHA512_H

typedef struct _sha512_ctx {
    uint64  state[8];
    uint64  len;
    uint64  lenh;
    uint8   data[128];
} sha512_ctx;

extern void sha512_init(sha512_ctx * ctx);
extern void sha512_transform(uint8 const * data,  uint64 * state);
extern void sha512_update(sha512_ctx * ctx, uint8 const * data, size_t len);
extern void sha512_final(sha512_ctx * ctx, uint8 * hash);
extern void sha512_hash(uint8 * hash, char const * data, size_t len);

#endif

