#!/bin/sh -e

WDIR="work"
SDIR="src"
RDIR="rules_example"
TDIR="./work/fproxy-target"

if [ ! -f $WDIR/dashboard ]; then
  echo "Please compile first"
  exit 1
fi

rm -Rf $TDIR
mkdir $TDIR $TDIR/bin

cp -p $WDIR/proxy $TDIR/bin/fproxy
cp -p $WDIR/proxy_r $TDIR/bin/fproxy_r
cp -p $WDIR/dashboard $TDIR/bin/fproxy-dashboard
cp -p $WDIR/cache_add $TDIR/bin/fproxy-cache_add
cp -p $WDIR/cacheconv-78 $TDIR/bin/fproxy-cacheconv-78
cp -p $WDIR/ssl-client-wrapper $WDIR/ssl-server-wrapper $TDIR/bin/

cat $SDIR/handle/rules_.txt $RDIR/rules_block.txt > $TDIR/rules_block.txt
cat $SDIR/handle/rules_.txt $RDIR/rules_cache.txt > $TDIR/rules_cache.txt
cat $SDIR/handle/rules_.txt $RDIR/rules_cookie.txt > $TDIR/rules_cookie.txt
cat $SDIR/handle/rules_.txt $RDIR/rules_raw.txt > $TDIR/rules_raw.txt
cat $SDIR/handle/rules_.txt $RDIR/rules_save.txt > $TDIR/rules_save.txt
cat $SDIR/handle/rules_.txt $RDIR/rules_sniff.txt > $TDIR/rules_sniff.txt
cat $SDIR/handle/rules_.txt $RDIR/rules_rproxy.txt > $TDIR/rules_rproxy.txt
cp $SDIR/handle/rules_resolv.txt $TDIR/
cp $RDIR/proxy.sh $RDIR/proxy.conf $TDIR/
cat $SDIR/LICENSE.txt > $TDIR/LICENSE.txt
echo " " >> $TDIR/LICENSE.txt
echo "Project WWW homepage: https://dev.m1089.ru/fproxy" >> $TDIR/LICENSE.txt
echo " " >> $TDIR/LICENSE.txt

cd $TDIR
mkdir cache_data cache_real saved_data saved_real cert-pin cert-pin/certs cert-pin/queue cert-pin/cache dyn-certs internal log pem proxy_temp tmp
chmod 700 . *
chmod 600 rules_*.txt proxy.conf
chmod 444 LICENSE.txt
echo 0 > dyn-cert-serial
echo 0 > mincache.time
echo 0 > offline.flag

openssl genrsa -out pem/cakey.pem 4096
openssl genrsa -out pem/proxykey.pem 4096
openssl req -x509 -new -key pem/cakey.pem -days 10000 -out pem/cacert.pem

chmod 400 pem/*.pem
cp pem/cacert.pem ../

if [ -z "$PREPARE_SILENT" ]; then
  echo "directory $TDIR prepared"
  echo "created certificate ./work/cacert.pem that should be installed as trusted root CA into browser"
  echo "DONE"
fi
