/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * dashboard.h - dashboard implementation
 * Copyright (c) 2018-2020 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

extern void dashboard_init(void);
extern void dashboard_set_num(unsigned int n);
extern void dashboard_reopen(void);
extern void dashboard_begin_request(void);
extern void dashboard_set_request(unsigned int method, unsigned int is_ssl, char const * host, char const * url);
extern void dashboard_set_host(char const * host);
extern void dashboard_set_rctype(char const * ctype);
extern void dashboard_set_rclen(unsigned long long clen);
extern void dashboard_set_rdlen(unsigned long long dlen);
extern void dashboard_set_ctype(char const * ctype);
extern void dashboard_set_clen(unsigned long long clen);
extern void dashboard_set_dlen(unsigned long long dlen);
extern void dashboard_received_request(void);
extern void dashboard_resolved_domain(void);
extern void dashboard_connected_target(void);
extern void dashboard_keepalive(void);
extern void dashboard_end_request(void);
extern int  dashboard_longest_keepalive(unsigned int numchilds, unsigned int minfree);
