/* (c) firk 2011-2013
   please respect the authorship
   feel free to use this code for anything */
#include "eventlog.h"
#include <stdio.h>
#include <stdarg.h>
#include <time.h>

#ifdef WIN32
#define vsnprintf _vsnprintf
#endif

extern void eventlog(int level, char const * mod, char const * fmt, ...) {
    char           timestr[64];
    char           buf[1024];
    time_t         now;
    struct tm *    tmnow;
    
    time(&now);
    tmnow = localtime(&now);
    if(!tmnow) sprintf(timestr, "%019lu", (unsigned long)now);
    else sprintf(timestr, "%04u/%02u/%02u %02u:%02u:%02u", tmnow->tm_year+1900, tmnow->tm_mon+1, tmnow->tm_mday, tmnow->tm_hour, tmnow->tm_min, tmnow->tm_sec);
    
    va_list arg;
    va_start(arg, fmt);
    vsnprintf(buf, sizeof(buf), fmt, arg);
    buf[sizeof(buf)-1] = 0; /* this required due to buggy windows vsnprintf */
    va_end(arg);
    
    fprintf(stdout, "[%s] %s: %s\n", timestr, mod, buf);
    fflush(stdout);
}


