/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * gzip.h - zlib wrapper to deal with gzipped http
 * Copyright (c) 2018, 2021 (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

extern int gzip_compress(t_dynbuf * destb, t_dynbuf * srcb, int level, int * z_err);
extern int gzip_decompress(t_dynbuf * destb, t_dynbuf * srcb, int * z_err);
extern int gzip_decompressfd(t_dynbuf * destb, int srcfd, int * z_err);
extern int gzip_decompressfd_check(t_dynbuf * destb, int srcfd, int * z_err);
extern int calc_randomless(unsigned char const * b, size_t n);

