/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * handle/inc.proxyctl.c - web interface to manage proxy
 * Copyright (c) 2018 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

static void proxyctl_main(char meth, char const * url, char const * ref, t_http_content const * postdata) {
  t_dynbuf out;
  char const * ctype;
  unsigned int status;
  
  status = STATUS_200;
  ctype = "text/html";
  dynbuf_init(&out, 16384, 16384, 1048575);
  
  
  if(ref && !skip_prefix((char*)ref,"https://proxyctl/")) {
    status = STATUS_500;
    dynbuf_printf(&out, "bad referrer");
  } else {
    dynbuf_printf(&out, "nothing here");
  }
  
  
  print_basic_headers(status);
  printf("Content-Type: %s\r\n",ctype);
  printf("Content-Length: %lu\r\n",(ulong)out.len);
  printf("\r\n");
  outbytes(out.buf, out.len);
  dynbuf_clear(&out);
}

