/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * handle/inc.rewrite.c - http request and response altering hooks
 * Copyright (c) 2017-2020 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

// was rewrite.php
// return new url if HTTP redirect needed; return NULL if not; this function called before block check
static char const * do_pre_redirect_url(char method, char const * host, char const * url) {
  char tmp[50], *p, tmp2[120];
  char const * u;
  if(!strcmp(host,"d2fu6qsc3xtnne.cloudfront.net")) return tmp_sprintf("https://si.shimano.com%s", url);
  if(!strcmp(host,"habrastorage.org")) return tmp_sprintf("https://hsto.org%s", url);
  if(!strcmp(host,"rutracker.org")) return tmp_sprintf("https://rutracker.net%s", url);
  /*
  if(!strcmp(host,"youtu.be") || !strcmp(host,"www.youtu.be")) {
    if(*url!='/') return tmp_sprintf("https://www.youtube.com/");
    snprintf(tmp, sizeof(tmp), "%s", url+1);
    if(p=strchr(tmp,'?')) *p=0;
    return tmp_sprintf("https://www.youtube.com/watch?v=%s&disable_polymer=true", tmp);
  }
  if((!strcmp(host,"www.youtube.com") || !strcmp(host,"youtube.com")) && !strncmp(url,"/watch?",7)) {
    if(url[7]=='v' && url[8]=='=') snprintf(tmp, sizeof(tmp), "%s", url+9);
    else if(u=strstr(url+7,"&v=")) snprintf(tmp, sizeof(tmp), "%s", u+3);
    if(p=strchr(tmp,'&')) *p=0;
    snprintf(tmp2, sizeof(tmp2), "https://www.youtube.com/watch?v=%s&disable_polymer=true", tmp);
    if(strcmp(host,"www.youtube.com") || strcmp(url,tmp2+23)) return tmp_sprintf("%s",tmp2);
  }
  */
// TODO //  if($host==='an.yandex.ru' && isset($_GET['location'])) { return $_GET['location']; }
  return NULL;
}

// return new url if HTTP redirect needed; return NULL if not; this function called after block check
static char const * do_redirect_url(char method, char const * host, char const * url) {
#if 0
  // parse url
    $is_args=''; $args=array();
    if(($i=strpos($url,'?'))!==FALSE) {
      $is_args='?';
      if(strlen($url)>$i+1) $args=explode('&',substr($url,$i+1));
      $url=substr($url,0,$i);
    }
  // may handle and alter url part here ($url)
    // ...
  // fix spammy &utm_ args
    $n=count($args); $q='';
    for($i=0;$i<$n;$i++) {
      $a=$args[$i];
      if(substr($a,0,4)==='utm_') continue;
      if(strlen($q)) $q.='&';
      $q.=$a;
    }
    if(strlen($q)) $is_args='?'; else if(count($args)) $is_args='';
  // build new url
    $newurl = $url.$is_args.$q;
  // other actions
    if($host==='habrastorage.org') $newurl = 'https://hsto.org'.$newurl;
    if($host==='rutracker.org') $newurl = 'https://rutracker.net'.$newurl;
    return $newurl;
#endif
  return NULL;
}

// alter request parameter before doing it; this is completely hidden from client;
static void do_rewrite_url(char * p_method, char const * * host, char const * * url) {
  if(!strcmp(*host,"www.playground.ru") && !strcmp(*url,"/pm/")) { *url="/pm/2/"; return; }
}


static char const * so_mirrors[][3] = {
  { "web-answers.ru",     "/c/",         "<div class=\"source\"><a href=\"~\" data-wpel-link=\"external\" target=\"_blank\" class=\"wpel-icon-right\">Источник<span class=\"wpel-icon wpel-image wpel-icon-13\"></span></a></div>" },
  { "qarchive.ru",        "/",           "<a target=\"_blank\" href=\"~\">\tОригинал вопроса\t<small>(на английском)</small>\t</a>" },
  { "fooobar.com",        "/questions/", "<a class=\"aa-link\" href=\"~\" target=\"_blank\" rel=\"noopener\">источник</a>" },
  { "geekquestion.com",   "/",           "<a href=\"~\" rel=\"noopener\" target=\"_blank\">источник</a>" },
  { "ru.coredump.biz",    "/questions/", "<a class=\"fuente\" href=\"~\" target=\"_blank\" rel=\"noopener\">источник</a>" },
  { "coderoad.ru",        "/",           "<a href=\"~\" rel=\"nofollow noreferrer\">\t<small><i class=\"far fa-copy\"></i> Источник</small>\t</a>" },
  { NULL }
};

static int spchar(char c) { return (c==32 || c==9 || c==10 || c==13); }

static size_t str_match(char const * st, size_t stlen, char const * pattern, size_t * res, size_t nres) {
  size_t n;
  char c;
  n = 0;
  while(c=*pattern) {
    if(c=='\t') {
      pattern++;
      while(n<stlen && spchar(*st)) { st++; n++; }
      continue;
    }
    if(c=='~') {
      pattern++;
      if(nres) res[0] = n;
      while(n<stlen && *st!=*pattern) { st++; n++; }
      if(nres) { res[1] = n-res[0]; res+=2; nres--; }
      continue;
    }
    if(n>=stlen || *st!=c) return 0;
    st++;
    pattern++;
    n++;
  }
  return n;
}

/* may alter ctype (just *ctype="new/type"; ) and content (via dynbuf api) */
static void do_postproc(char method, char const * host, char const * url, char const * * ctype, t_dynbuf * content) {
  char const * (*sm)[3];
  char *st0, *st;
  size_t st0len, stlen;
  size_t rr[2];
  t_dynbuf res;
  
  st0 = (char*)content->buf;
  st0len = content->len;

  if(!strcmp(host,"www.rubattle.net") && !strncmp(*ctype,"text/html",9)) {
    while(st=strstr(st0,"<img width=1 height=1")) st[1]='!';
    return;
  }

  if(method==M_POST && !strcmp(host,"img.playground.ru") && !strcmp(url,"/upload/upload.php")) { *ctype = "text/plain"; return; }

  for(sm=so_mirrors; sm[0][0]; sm++) {
    if(strcmp(host, sm[0][0]) || !skip_prefix((char*)url, sm[0][1])) continue;
    for(st=st0,stlen=st0len; stlen; st++,stlen--) {
      if(str_match(st, stlen, sm[0][2], rr, 1)) {
        dynbuf_init(&res, 128, 128, 10000);
        dynbuf_printstr(&res, "<a href=\"");
        dynbuf_write(&res, st+rr[0], rr[1]);
        dynbuf_printstr(&res, "\">");
        dynbuf_write(&res, st+rr[0], rr[1]);
        dynbuf_printstr(&res, "</a>");
        dynbuf_clear(content);
        *content = res;
        return;
      }
    }
  }
}

