/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * handle/inc.rules.c - hardcoded proxy-rules
 * Copyright (c) 2017-2018,2019 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

/* this file contains part of rules.php that was no translated to rules.c */
/* this is rules that does not worth softcoding or have problems with that */

static int is_strip_referer(char const * host, char const * url, char const * referer) {
/// TODO: softcode it?
  if(skip_prefix((char*)referer,"http://news-clck.yandex.ru/") || skip_prefix((char*)referer,"https://news-clck.yandex.ru/")) return 1;
  return 0;
}



/* this is for cache storage only, not for http requests or redirects */
static void rewrite_url(char const * host, char const * * url) {
  if(!strcmp(host,"www.playground.ru")) {
    if(skip_prefix((char*)*url,"/js/old/jquery.plugins.js?")) *url="/js/old/jquery.plugins.js";
  }
}

static long is_offline(void) {
  FILE * fp;
  char buf[50];
  if(fp = fopen("./offline.flag","rb")) {
    if(fgets(buf, sizeof(buf), fp)) { fclose(fp); return strtol(buf, NULL, 10); }
    fclose(fp);
  }
  return 0;
}

static long min_cache_date(void) {
  FILE * fp;
  char buf[50];
  if(fp = fopen("./mincache.date","rb")) {
    if(fgets(buf, sizeof(buf), fp)) { fclose(fp); return strtol(buf, NULL, 10); }
    fclose(fp);
  }
  return 0;
}



static char const * replace_user_agent(char const * host, char const * url) {
  size_t l;
  if(!strcmp(host,"youtube.com") || (l=strlen(host))>=12 && !strcmp(host+l-12,".youtube.com"))
    return "Googlebot/2.1 (+http://www.googlebot.com/bot.html)";
  return NULL;
}
