/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * handle/rules.h - rules-files parse and lookup
 * Copyright (c) 2018, 2021 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

extern char const * rules_match_name(int r);
extern void rules_load(void);
extern int is_blocked(char const * host, char const * url);
extern int block_cookie(char const * host, char const * url);
extern int need_cache(char const * host, char const * url, char const * ctype);
extern int is_raw(char const * host, char const * url);
extern int is_save(char const * host, char const * url);
extern int is_sniff(char const * host, char const * url);
extern int is_rproxy(char const * host, char const * url);

