/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * helpers/cert_gen.h - server certificate generator
 * Copyright (c) 2018-2019 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */


extern EVP_PKEY * read_pkey(char const * fn);
extern X509 * read_cert(char const * fn);
extern X509 * gen_dyncert(EVP_PKEY * cakey, X509 * cacert, EVP_PKEY * serverkey, char const * servername, int use_SAN);
extern X509 * gen_dyncert_cache(EVP_PKEY * cakey, X509 * cacert, EVP_PKEY * serverkey, char const * servername, int use_SAN);

