/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * helpers/cert_match.h - check that certificate matches hostname
 * Copyright (c) 2018 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */

#ifndef INCLUDED_CERT_MATCH_H
#define INCLUDED_CERT_MATCH_H

#define CERT_MATCH_MISSING_HOSTNAME 1   /* nothing match to; argument "hostname" is NULL */
#define CERT_MATCH_OK               0   /* certificate mateched hostname - ok */
#define CERT_MATCH_MISSING_CERT     -1  /* missing certificate (it is NULL) */
#define CERT_MATCH_MALFORMED_CERT   -2  /* malformed certificate */
#define CERT_MATCH_NO               -3  /* hostname mismatch cert */
#define CERT_MATCH_MISSING_CN       -4  /* certificate does not contain SAN and does not contain CN; this may be considered as malformed cert */
#define CERT_MATCH_INTERNAL_BUG     -5  /* bug happened in openssl or this code */

extern int cert_match(X509 const * cert, char const * hostname);

#endif
