/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * helpers/cert_verify.h - check if certificate trusted or not
 * Copyright (c) 2020, 2022 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */


extern int cert_verify_with_cache(X509_STORE_CTX * ctx, void * udata);
extern int cert_verify_without_cache(X509_STORE_CTX * ctx, void * udata);
extern void cert_verify_set_flags(int download_aia_issuers);
extern void cert_verify_set_save_chains(int save_chains);
extern void cert_verify_set_dump_chains(int level);
extern STACK_OF(X509) * cert_verify_get_saved_untrusted(void);
extern STACK_OF(X509) * cert_verify_get_saved_trusted(void);

