/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * helpers/http_download.h - download certificates or just small files via http
 * Copyright (c) 2020 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */


/* return:
  -1 = bad input data (bad url)
  -2 = networking error (connecting), errno set
  -3 = networking error (after connecting), errno set
  -4 = bad reply (should not happen - it is reply from local proxy)
  0 = ok
  */
extern int http_download(char const * proxysock, char const * url, size_t size_limit, uint8 * * res, size_t * rbytes, unsigned int * status);

