/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * util.h - various utility functions
 * Copyright (c) 2018-2020 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */


extern void * xmalloc(size_t sz);
extern void * xmallocz(size_t sz);
extern char * xstrdup(char const * st);
extern void * xmemdup(void const * p0, size_t sz);
#define xfree(A) free(A)
extern void strtolower(char * st);
extern char * skip_prefix(char * st, char const * prefix);
#define write_all(a,b,c) write_all_2(a,b,c,NULL)
extern int write_all_2(int fd, void const * buf, size_t sz, unsigned long * inc);
extern ssize_t read_safe(int fd, void * buf, size_t sz);
extern void compact_string(char * dest, char const * src);


#include <fcl/dynbufs.h>
/*
 ***************** dynbuf *****************
 
 dynbuf_init_file do not respects errno and all its error reporting done via returned value:
 0=ok -1=file can't be opened; -2=file exists but can't read; -3=not enough space in dynbuf
 even in error state, dynbuf will be in some initialized state (so, dynbuf_clear() required)
   and may be with some partial read data
 */

extern void dynbuf_init_local(t_dynbuf * dynbuf, size_t init, size_t step, size_t max);
extern int  dynbuf_init_file(t_dynbuf * db, char const * fn);
#ifdef UTIL_TIME /* time_t not always available */
extern int  dynbuf_init_file_mintime(t_dynbuf * db, char const * fn, time_t mintime);
#endif

#define dynbuf_init dynbuf_init_local
#define dynbuf_init_data dynbuf_init_data_check
